<?php
/**
 * InlineResponse20061ContentEmployees
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineResponse20061ContentEmployees Class Doc Comment
 *
 * @category Class
 * @description object containing a found employee with all associated infos
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineResponse20061ContentEmployees implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_response_200_61_content_employees';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'string',
        'name' => 'string',
        'firstName' => 'string',
        'lastName' => 'string',
        'departmentId' => 'string',
        'role' => 'string',
        'phoneNr' => 'string',
        'phoneNr2' => 'string',
        'email' => 'string',
        'mobileNr' => 'string',
        'mobileNr2' => 'string',
        'privateNr' => 'string',
        'companies' => 'int[]',
        'active' => 'bool',
        'anticipatedCallbacks' => 'object[]',
        'categories' => 'int[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'id' => null,
        'name' => null,
        'firstName' => null,
        'lastName' => null,
        'departmentId' => null,
        'role' => null,
        'phoneNr' => null,
        'phoneNr2' => null,
        'email' => null,
        'mobileNr' => null,
        'mobileNr2' => null,
        'privateNr' => null,
        'companies' => null,
        'active' => null,
        'anticipatedCallbacks' => null,
        'categories' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'name' => 'name',
        'firstName' => 'firstName',
        'lastName' => 'lastName',
        'departmentId' => 'departmentId',
        'role' => 'role',
        'phoneNr' => 'phoneNr',
        'phoneNr2' => 'phoneNr2',
        'email' => 'email',
        'mobileNr' => 'mobileNr',
        'mobileNr2' => 'mobileNr2',
        'privateNr' => 'privateNr',
        'companies' => 'companies',
        'active' => 'active',
        'anticipatedCallbacks' => 'anticipatedCallbacks',
        'categories' => 'categories'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'name' => 'setName',
        'firstName' => 'setFirstName',
        'lastName' => 'setLastName',
        'departmentId' => 'setDepartmentId',
        'role' => 'setRole',
        'phoneNr' => 'setPhoneNr',
        'phoneNr2' => 'setPhoneNr2',
        'email' => 'setEmail',
        'mobileNr' => 'setMobileNr',
        'mobileNr2' => 'setMobileNr2',
        'privateNr' => 'setPrivateNr',
        'companies' => 'setCompanies',
        'active' => 'setActive',
        'anticipatedCallbacks' => 'setAnticipatedCallbacks',
        'categories' => 'setCategories'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'name' => 'getName',
        'firstName' => 'getFirstName',
        'lastName' => 'getLastName',
        'departmentId' => 'getDepartmentId',
        'role' => 'getRole',
        'phoneNr' => 'getPhoneNr',
        'phoneNr2' => 'getPhoneNr2',
        'email' => 'getEmail',
        'mobileNr' => 'getMobileNr',
        'mobileNr2' => 'getMobileNr2',
        'privateNr' => 'getPrivateNr',
        'companies' => 'getCompanies',
        'active' => 'getActive',
        'anticipatedCallbacks' => 'getAnticipatedCallbacks',
        'categories' => 'getCategories'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }


    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = $data['id'] ?? null;
        $this->container['name'] = $data['name'] ?? null;
        $this->container['firstName'] = $data['firstName'] ?? null;
        $this->container['lastName'] = $data['lastName'] ?? null;
        $this->container['departmentId'] = $data['departmentId'] ?? null;
        $this->container['role'] = $data['role'] ?? null;
        $this->container['phoneNr'] = $data['phoneNr'] ?? null;
        $this->container['phoneNr2'] = $data['phoneNr2'] ?? null;
        $this->container['email'] = $data['email'] ?? null;
        $this->container['mobileNr'] = $data['mobileNr'] ?? null;
        $this->container['mobileNr2'] = $data['mobileNr2'] ?? null;
        $this->container['privateNr'] = $data['privateNr'] ?? null;
        $this->container['companies'] = $data['companies'] ?? null;
        $this->container['active'] = $data['active'] ?? null;
        $this->container['anticipatedCallbacks'] = $data['anticipatedCallbacks'] ?? null;
        $this->container['categories'] = $data['categories'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return string|null
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param string|null $id id of the employee
     *
     * @return self
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets name
     *
     * @return string|null
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     *
     * @param string|null $name full (displayed) name
     *
     * @return self
     */
    public function setName($name)
    {
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets firstName
     *
     * @return string|null
     */
    public function getFirstName()
    {
        return $this->container['firstName'];
    }

    /**
     * Sets firstName
     *
     * @param string|null $firstName first name
     *
     * @return self
     */
    public function setFirstName($firstName)
    {
        $this->container['firstName'] = $firstName;

        return $this;
    }

    /**
     * Gets lastName
     *
     * @return string|null
     */
    public function getLastName()
    {
        return $this->container['lastName'];
    }

    /**
     * Sets lastName
     *
     * @param string|null $lastName last name
     *
     * @return self
     */
    public function setLastName($lastName)
    {
        $this->container['lastName'] = $lastName;

        return $this;
    }

    /**
     * Gets departmentId
     *
     * @return string|null
     */
    public function getDepartmentId()
    {
        return $this->container['departmentId'];
    }

    /**
     * Sets departmentId
     *
     * @param string|null $departmentId department id of the employee, the name is given in the \"linked entities\"
     *
     * @return self
     */
    public function setDepartmentId($departmentId)
    {
        $this->container['departmentId'] = $departmentId;

        return $this;
    }

    /**
     * Gets role
     *
     * @return string|null
     */
    public function getRole()
    {
        return $this->container['role'];
    }

    /**
     * Sets role
     *
     * @param string|null $role role of the employee
     *
     * @return self
     */
    public function setRole($role)
    {
        $this->container['role'] = $role;

        return $this;
    }

    /**
     * Gets phoneNr
     *
     * @return string|null
     */
    public function getPhoneNr()
    {
        return $this->container['phoneNr'];
    }

    /**
     * Sets phoneNr
     *
     * @param string|null $phoneNr phone number
     *
     * @return self
     */
    public function setPhoneNr($phoneNr)
    {
        $this->container['phoneNr'] = $phoneNr;

        return $this;
    }

    /**
     * Gets phoneNr2
     *
     * @return string|null
     */
    public function getPhoneNr2()
    {
        return $this->container['phoneNr2'];
    }

    /**
     * Sets phoneNr2
     *
     * @param string|null $phoneNr2 phone number
     *
     * @return self
     */
    public function setPhoneNr2($phoneNr2)
    {
        $this->container['phoneNr2'] = $phoneNr2;

        return $this;
    }

    /**
     * Gets email
     *
     * @return string|null
     */
    public function getEmail()
    {
        return $this->container['email'];
    }

    /**
     * Sets email
     *
     * @param string|null $email email
     *
     * @return self
     */
    public function setEmail($email)
    {
        $this->container['email'] = $email;

        return $this;
    }

    /**
     * Gets mobileNr
     *
     * @return string|null
     */
    public function getMobileNr()
    {
        return $this->container['mobileNr'];
    }

    /**
     * Sets mobileNr
     *
     * @param string|null $mobileNr mobile phone number
     *
     * @return self
     */
    public function setMobileNr($mobileNr)
    {
        $this->container['mobileNr'] = $mobileNr;

        return $this;
    }

    /**
     * Gets mobileNr2
     *
     * @return string|null
     */
    public function getMobileNr2()
    {
        return $this->container['mobileNr2'];
    }

    /**
     * Sets mobileNr2
     *
     * @param string|null $mobileNr2 mobile phone number
     *
     * @return self
     */
    public function setMobileNr2($mobileNr2)
    {
        $this->container['mobileNr2'] = $mobileNr2;

        return $this;
    }

    /**
     * Gets privateNr
     *
     * @return string|null
     */
    public function getPrivateNr()
    {
        return $this->container['privateNr'];
    }

    /**
     * Sets privateNr
     *
     * @param string|null $privateNr private phone number
     *
     * @return self
     */
    public function setPrivateNr($privateNr)
    {
        $this->container['privateNr'] = $privateNr;

        return $this;
    }

    /**
     * Gets companies
     *
     * @return int[]|null
     */
    public function getCompanies()
    {
        return $this->container['companies'];
    }

    /**
     * Sets companies
     *
     * @param int[]|null $companies shows assigned companies of this user, the name is given in the \"linked entities\"
     *
     * @return self
     */
    public function setCompanies($companies)
    {
        $this->container['companies'] = $companies;

        return $this;
    }

    /**
     * Gets active
     *
     * @return bool|null
     */
    public function getActive()
    {
        return $this->container['active'];
    }

    /**
     * Sets active
     *
     * @param bool|null $active determines wether an employee is active or not
     *
     * @return self
     */
    public function setActive($active)
    {
        $this->container['active'] = $active;

        return $this;
    }

    /**
     * Gets anticipatedCallbacks
     *
     * @return object[]|null
     */
    public function getAnticipatedCallbacks()
    {
        return $this->container['anticipatedCallbacks'];
    }

    /**
     * Sets anticipatedCallbacks
     *
     * @param object[]|null $anticipatedCallbacks anticipatedCallbacks
     *
     * @return self
     */
    public function setAnticipatedCallbacks($anticipatedCallbacks)
    {
        $this->container['anticipatedCallbacks'] = $anticipatedCallbacks;

        return $this;
    }

    /**
     * Gets categories
     *
     * @return int[]|null
     */
    public function getCategories()
    {
        return $this->container['categories'];
    }

    /**
     * Sets categories
     *
     * @param int[]|null $categories ids of all employee categories (if defined in the employee search configuration). The names are given in the \"linked entities\" - \"employeeCategories\"
     *
     * @return self
     */
    public function setCategories($categories)
    {
        $this->container['categories'] = $categories;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


